#include <string.h>

#include "data.h"
#include "panic.h"
#include "mod.h"


char *
stringize_token(struct tok_data td)
{
        char *ret;
        ret = malloc(td.len + 1);
        if(!ret)
                panicno("stringize_token");
        memcpy(ret, td.data, td.len);
        ret[td.len] = '\0';
        return ret;
}

void 
dump_maps(FILE *file, struct map *map, int count)
{
        int i = 0;
        for(; i < count; i++, map++) {
                fprintf(file, "key <");
                print_key(file, &map->leader);
                fprintf(file, "> ");
                map->string && map->string[0] && fprintf(file, "string \"%s\" ", map->string);
                switch(map->atype) {
                case ACTION_EXEC:
                        fprintf(file, "exec %s\n",  map->adata);
                        break;
                case ACTION_INJECT:
                        fprintf(file, "inject \"%s\"\n",  map->adata);
                        break;
                case ACTION_EXIT:
                        fprintf(file, "exit\n");
                        break;
                case ACTION_DIE:
                        fprintf(file, "die\n");
                        break;
                default:
                        fprintf(file, "unknown\n");
                        break;

                
                }
        }
}
