/* Driver template for the LEMON parser generator.
** Copyright 1991-1995 by D. Richard Hipp.
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
** 
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the
** Free Software Foundation, Inc., 59 Temple Place - Suite 330,
** Boston, MA  02111-1307, USA.
**
** Modified 1997 to make it suitable for use with makeheaders.
*/
/* First off, code is include which follows the "include" declaration
** in the input file. */
#include <stdio.h>
#line 2 "./parser.y"
 
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include "data.h" 
#include "panic.h" 
#include "mod.h" 

#line 34 "parser.c"
/* Next is all token values, in a form suitable for use by makeheaders.
** This section will be null unless lemon is run with the -m switch.
*/
/* 
** These constants (all generated automatically by the parser generator)
** specify the various kinds of tokens (terminals) that the parser
** understands. 
**
** Each symbol here is a terminal symbol in the grammar.
*/
/* Make sure the INTERFACE macro is defined.
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/* The next thing included is series of defines which control
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 terminals
**                       and nonterminals.  "int" is used otherwise.
**    YYNOCODE           is a number of type YYCODETYPE which corresponds
**                       to no legal terminal or nonterminal number.  This
**                       number is used to fill in empty slots of the hash 
**                       table.
**    YYACTIONTYPE       is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 rules and
**                       states combined.  "int" is used otherwise.
**    ParseTOKENTYPE     is the data type used for minor tokens given 
**                       directly to the parser from the tokenizer.
**    YYMINORTYPE        is the data type used for all minor tokens.
**                       This is typically a union of many types, one of
**                       which is ParseTOKENTYPE.  The entry in the union
**                       for base tokens is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.
**    ParseARGDECL       is a declaration of a 3rd argument to the
**                       parser, or null if there is no extra argument.
**    ParseKRARGDECL     A version of ParseARGDECL for K&R C.
**    ParseANSIARGDECL   A version of ParseARGDECL for ANSI C.
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
*/
/*  */
#define YYCODETYPE unsigned char
#define YYNOCODE 19
#define YYACTIONTYPE unsigned char
#define ParseTOKENTYPE  struct tok_data 
typedef union {
  ParseTOKENTYPE yy0;
  int yy4;
  struct { enum action_type atype; char *adata; } yy20;
  int yy37;
} YYMINORTYPE;
#define YYSTACKDEPTH 100
#define ParseARGDECL ,pd 
#define ParseXARGDECL  struct parse_data *pd ;
#define ParseANSIARGDECL , struct parse_data *pd 
#define YYNSTATE 20
#define YYNRULE 12
#define YYERRORSYMBOL 14
#define YYERRSYMDT yy37
#define YY_NO_ACTION      (YYNSTATE+YYNRULE+2)
#define YY_ACCEPT_ACTION  (YYNSTATE+YYNRULE+1)
#define YY_ERROR_ACTION   (YYNSTATE+YYNRULE)
/* Next is the action table.  Each entry in this table contains
**
**  +  An integer which is the number representing the look-ahead
**     token
**
**  +  An integer indicating what action to take.  Number (N) between
**     0 and YYNSTATE-1 mean shift the look-ahead and go to state N.
**     Numbers between YYNSTATE and YYNSTATE+YYNRULE-1 mean reduce by
**     rule N-YYNSTATE.  Number YYNSTATE+YYNRULE means that a syntax
**     error has occurred.  Number YYNSTATE+YYNRULE+1 means the parser
**     accepts its input.
**
**  +  A pointer to the next entry with the same hash value.
**
** The action table is really a series of hash tables.  Each hash
** table contains a number of entries which is a power of two.  The
** "state" table (which follows) contains information about the starting
** point and size of each hash table.
*/
struct yyActionEntry {
  YYCODETYPE   lookahead;   /* The value of the look-ahead token */
  YYACTIONTYPE action;      /* Action to take for this look-ahead */
  struct yyActionEntry *next; /* Next look-ahead with the same hash, or NULL */
};
static struct yyActionEntry yyActionTable[] = {
/* State 0 */
  {   0,  22, 0                    }, /*                      $ reduce 2 */
  {   5,   4, 0                    }, /*                    KEY shift  4 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {  12,   2, 0                    }, /*                   decl shift  2 */
  {  13,   1, &yyActionTable[   1] }, /*                  decls shift  1 */
  {YYNOCODE,0,0}, /* Unused */
  {  15,  33, 0                    }, /*                   file accept */
/* State 1 */
  {   0,  20, 0                    }, /*                      $ reduce 0 */
/* State 2 */
  {  12,   2, &yyActionTable[  11] }, /*                   decl shift  2 */
  {  13,   3, &yyActionTable[  12] }, /*                  decls shift  3 */
  {   0,  22, 0                    }, /*                      $ reduce 2 */
  {   5,   4, 0                    }, /*                    KEY shift  4 */
/* State 3 */
  {   0,  21, 0                    }, /*                      $ reduce 1 */
/* State 4 */
  {   6,   5, 0                    }, /*                 KEYVAL shift  5 */
/* State 5 */
  {   3,  17, 0                    }, /*                   EXIT shift  17 */
  {   1,  18, 0                    }, /*                    DIE shift  18 */
  {   2,  14, 0                    }, /*                   EXEC shift  14 */
  {  11,   6, &yyActionTable[  15] }, /*                 action shift  6 */
  {   4,  15, 0                    }, /*                 INJECT shift  15 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {   7,   7, 0                    }, /*                 LBRACE shift  7 */
/* State 6 */
  {YYNOCODE,0,0}, /* Unused */
/* State 7 */
  {  16,  10, &yyActionTable[  26] }, /*                  sdecl shift  10 */
  {  17,   8, &yyActionTable[  27] }, /*                 sdecls shift  8 */
  {   8,  30, 0                    }, /*                 RBRACE reduce 10 */
  {   9,  12, 0                    }, /*                 STRING shift  12 */
/* State 8 */
  {   8,   9, 0                    }, /*                 RBRACE shift  9 */
/* State 9 */
  {YYNOCODE,0,0}, /* Unused */
/* State 10 */
  {  16,  10, &yyActionTable[  32] }, /*                  sdecl shift  10 */
  {  17,  11, &yyActionTable[  33] }, /*                 sdecls shift  11 */
  {   8,  30, 0                    }, /*                 RBRACE reduce 10 */
  {   9,  12, 0                    }, /*                 STRING shift  12 */
/* State 11 */
  {   8,  29, 0                    }, /*                 RBRACE reduce 9 */
/* State 12 */
  {  10,  13, 0                    }, /*              STRINGVAL shift  13 */
/* State 13 */
  {   3,  17, 0                    }, /*                   EXIT shift  17 */
  {   1,  18, 0                    }, /*                    DIE shift  18 */
  {   2,  14, 0                    }, /*                   EXEC shift  14 */
  {  11,  19, &yyActionTable[  36] }, /*                 action shift  19 */
  {   4,  15, 0                    }, /*                 INJECT shift  15 */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
  {YYNOCODE,0,0}, /* Unused */
/* State 14 */
  {YYNOCODE,0,0}, /* Unused */
/* State 15 */
  {  10,  16, 0                    }, /*              STRINGVAL shift  16 */
/* State 16 */
  {YYNOCODE,0,0}, /* Unused */
/* State 17 */
  {YYNOCODE,0,0}, /* Unused */
/* State 18 */
  {YYNOCODE,0,0}, /* Unused */
/* State 19 */
  {YYNOCODE,0,0}, /* Unused */
};

/* The state table contains information needed to look up the correct
** action in the action table, given the current state of the parser.
** Information needed includes:
**
**  +  A pointer to the start of the action hash table in yyActionTable.
**
**  +  A mask used to hash the look-ahead token.  The mask is an integer
**     which is one less than the size of the hash table.  
**
**  +  The default action.  This is the action to take if no entry for
**     the given look-ahead is found in the action hash table.
*/
struct yyStateEntry {
  struct yyActionEntry *hashtbl; /* Start of the hash table in yyActionTable */
  int mask;                      /* Mask used for hashing the look-ahead */
  YYACTIONTYPE actionDefault;    /* Default action if look-ahead not found */
};
static struct yyStateEntry yyStateTable[] = {
  { &yyActionTable[0], 7, 32},
  { &yyActionTable[8], 0, 32},
  { &yyActionTable[9], 3, 32},
  { &yyActionTable[13], 0, 32},
  { &yyActionTable[14], 0, 32},
  { &yyActionTable[15], 7, 32},
  { &yyActionTable[23], 0, 23},
  { &yyActionTable[24], 3, 32},
  { &yyActionTable[28], 0, 32},
  { &yyActionTable[29], 0, 24},
  { &yyActionTable[30], 3, 32},
  { &yyActionTable[34], 0, 32},
  { &yyActionTable[35], 0, 32},
  { &yyActionTable[36], 7, 32},
  { &yyActionTable[44], 0, 25},
  { &yyActionTable[45], 0, 32},
  { &yyActionTable[46], 0, 26},
  { &yyActionTable[47], 0, 27},
  { &yyActionTable[48], 0, 28},
  { &yyActionTable[49], 0, 31},
};

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
*/
struct yyStackEntry {
  int stateno;       /* The state-number */
  int major;         /* The major token value.  This is the code
                     ** number for the token at this stack level */
  YYMINORTYPE minor; /* The user-supplied minor token value.  This
                     ** is the value of the token  */
};

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  int idx;                            /* Index of top element in stack */
  int errcnt;                         /* Shifts left before out of the error */
  struct yyStackEntry *top;           /* Pointer to the top stack element */
  struct yyStackEntry stack[YYSTACKDEPTH];  /* The parser's stack */
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;

/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void ParseTrace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}

/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static char *yyTokenName[] = { 
  "$",             "DIE",           "EXEC",          "EXIT",        
  "INJECT",        "KEY",           "KEYVAL",        "LBRACE",      
  "RBRACE",        "STRING",        "STRINGVAL",     "action",      
  "decl",          "decls",         "error",         "file",        
  "sdecl",         "sdecls",      
};
#define YYTRACE(X) if( yyTraceFILE ) fprintf(yyTraceFILE,"%sReduce [%s].\n",yyTracePrompt,X);
#else
#define YYTRACE(X)
#endif

/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to Parse and ParseFree.
*/
void *ParseAlloc(void *(*mallocProc)(int)){
  yyParser *pParser;
  pParser = (yyParser*)(*mallocProc)( (int)sizeof(yyParser) );
  if( pParser ){
    pParser->idx = -1;
  }
  return pParser;
}

/* The following function deletes the value associated with a
** symbol.  The symbol can be either a terminal or nonterminal.
** "yymajor" is the symbol code, and "yypminor" is a pointer to
** the value.
*/
static void yy_destructor(YYCODETYPE yymajor, YYMINORTYPE *yypminor){
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are not used
    ** inside the C code.
    */
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
**
** Return the major token number for the symbol popped.
*/
static int yy_pop_parser_stack(yyParser *pParser){
  YYCODETYPE yymajor;

  if( pParser->idx<0 ) return 0;
#ifndef NDEBUG
  if( yyTraceFILE && pParser->idx>=0 ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[pParser->top->major]);
  }
#endif
  yymajor = pParser->top->major;
  yy_destructor( yymajor, &pParser->top->minor);
  pParser->idx--;
  pParser->top--;
  return yymajor;
}

/* 
** Deallocate and destroy a parser.  Destructors are all called for
** all stack elements before shutting the parser down.
**
** Inputs:
** <ul>
** <li>  A pointer to the parser.  This should be a pointer
**       obtained from ParseAlloc.
** <li>  A pointer to a function used to reclaim memory obtained
**       from malloc.
** </ul>
*/
void ParseFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
  yyParser *pParser = (yyParser*)p;
  if( pParser==0 ) return;
  while( pParser->idx>=0 ) yy_pop_parser_stack(pParser);
  (*freeProc)((void*)pParser);
}

/*
** Find the appropriate action for a parser given the look-ahead token.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_parser_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead             /* The look-ahead token */
){
  struct yyStateEntry *pState;   /* Appropriate entry in the state table */
  struct yyActionEntry *pAction; /* Action appropriate for the look-ahead */
 
  /* if( pParser->idx<0 ) return YY_NO_ACTION;  */
  pState = &yyStateTable[pParser->top->stateno];
  if( iLookAhead!=YYNOCODE ){
    pAction = &pState->hashtbl[iLookAhead & pState->mask];
    while( pAction ){
      if( pAction->lookahead==iLookAhead ) return pAction->action;
      pAction = pAction->next;
    }
  }else if( pState->mask!=0 || pState->hashtbl->lookahead!=YYNOCODE ){
    return YY_NO_ACTION;
  }
  return pState->actionDefault;
}

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  int yyNewState,               /* The new state to shift in */
  int yyMajor,                  /* The major token to shift in */
  YYMINORTYPE *yypMinor         /* Pointer ot the minor token to shift in */
){
  yypParser->idx++;
  yypParser->top++;
  if( yypParser->idx>=YYSTACKDEPTH ){
     yypParser->idx--;
     yypParser->top--;
#ifndef NDEBUG
     if( yyTraceFILE ){
       fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
     }
#endif
     while( yypParser->idx>=0 ) yy_pop_parser_stack(yypParser);
     /* Here code is inserted which will execute if the parser
     ** stack every overflows */
     return;
  }
  yypParser->top->stateno = yyNewState;
  yypParser->top->major = yyMajor;
  yypParser->top->minor = *yypMinor;
#ifndef NDEBUG
  if( yyTraceFILE && yypParser->idx>0 ){
    int i;
    fprintf(yyTraceFILE,"%sShift %d\n",yyTracePrompt,yyNewState);
    fprintf(yyTraceFILE,"%sStack:",yyTracePrompt);
    for(i=1; i<=yypParser->idx; i++)
      fprintf(yyTraceFILE," %s",yyTokenName[yypParser->stack[i].major]);
    fprintf(yyTraceFILE,"\n");
  }
#endif
}

/* The following table contains information about every rule that
** is used during the reduce.
*/
static struct {
  YYCODETYPE lhs;         /* Symbol on the left-hand side of the rule */
  unsigned char nrhs;     /* Number of right-hand side symbols in the rule */
} yyRuleInfo[] = {
  { 15, 1 },
  { 13, 2 },
  { 13, 0 },
  { 12, 3 },
  { 12, 5 },
  { 11, 1 },
  { 11, 2 },
  { 11, 1 },
  { 11, 1 },
  { 17, 2 },
  { 17, 0 },
  { 16, 3 },
};

static void yy_accept(yyParser *  ParseANSIARGDECL);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
*/
static void yy_reduce(
  yyParser *yypParser,         /* The parser */
  int yyruleno                 /* Number of the rule by which to reduce */
  ParseANSIARGDECL
){
  int yygoto;                     /* The next state */
  int yyact;                      /* The next action */
  YYMINORTYPE yygotominor;        /* The LHS of the rule reduced */
  struct yyStackEntry *yymsp;     /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  yymsp = yypParser->top;
  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **     YYTRACE("<text of the rule>");
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
      case 0:
        YYTRACE("file ::= decls")
        /* No destructor defined for decls */
        break;
      case 1:
        YYTRACE("decls ::= decl decls")
        /* No destructor defined for decl */
        /* No destructor defined for decls */
        break;
      case 2:
        YYTRACE("decls ::=")
        break;
      case 3:
        YYTRACE("decl ::= KEY KEYVAL action")
#line 22 "./parser.y"
{
        int end = RB_LEN(&pd->rb) / sizeof(struct map);
        struct map map;
        char *keyc = stringize_token(yymsp[-1].minor.yy0);
        struct key key;
        memset(&map, 0, sizeof(map));
        key.name = strdup(keyc);
        pd->errorcount += parse_key(keyc, &key);
	free(keyc);
        map.adata = yymsp[0].minor.yy20.adata;
        map.atype = yymsp[0].minor.yy20.atype;
        map.string = "";
	map.leader = key;
        rb_append(&pd->rb, &map, sizeof(map));
        if(verbose_mode) {
                fprintf(stderr, "Appending map: ");
                dump_maps(stderr, &map, 1);
        }
}
#line 550 "parser.c"
        /* No destructor defined for KEY */
        break;
      case 4:
        YYTRACE("decl ::= KEY KEYVAL LBRACE sdecls RBRACE")
#line 42 "./parser.y"
{
        int end = RB_LEN(&pd->rb) / sizeof(struct map);
        int start = end - yymsp[-1].minor.yy4;
        char *keyc = stringize_token(yymsp[-3].minor.yy0);
        struct key key;
        key.name = strdup(keyc);
        pd->errorcount += parse_key(keyc, &key);
        free(keyc);
        assert(pd->rb_start % sizeof(struct map) == 0);
        assert(RB_LEN(&pd->rb) % sizeof(struct map) == 0);
        print_verbose("Setting leader: %s on %i maps", key.name, end - start);
        for(;start < end; start++) {
                ((struct map *)pd->rb.buf)[start].leader = key;
        }
}
#line 571 "parser.c"
        /* No destructor defined for KEY */
        /* No destructor defined for LBRACE */
        /* No destructor defined for RBRACE */
        break;
      case 5:
        YYTRACE("action ::= EXEC")
#line 58 "./parser.y"
{ yygotominor.yy20.atype = ACTION_EXEC; yygotominor.yy20.adata = stringize_token(yymsp[0].minor.yy0); }
#line 580 "parser.c"
        break;
      case 6:
        YYTRACE("action ::= INJECT STRINGVAL")
#line 59 "./parser.y"
{ yygotominor.yy20.atype = ACTION_INJECT; yygotominor.yy20.adata = stringize_token(yymsp[0].minor.yy0); }
#line 586 "parser.c"
        /* No destructor defined for INJECT */
        break;
      case 7:
        YYTRACE("action ::= EXIT")
#line 60 "./parser.y"
{ yygotominor.yy20.atype = ACTION_EXIT; yygotominor.yy20.adata = NULL; }
#line 593 "parser.c"
        /* No destructor defined for EXIT */
        break;
      case 8:
        YYTRACE("action ::= DIE")
#line 61 "./parser.y"
{ yygotominor.yy20.atype = ACTION_DIE; yygotominor.yy20.adata = NULL; }
#line 600 "parser.c"
        /* No destructor defined for DIE */
        break;
      case 9:
        YYTRACE("sdecls ::= sdecl sdecls")
#line 64 "./parser.y"
{ yygotominor.yy4 = yymsp[0].minor.yy4 + 1; }
#line 607 "parser.c"
        /* No destructor defined for sdecl */
        break;
      case 10:
        YYTRACE("sdecls ::=")
#line 65 "./parser.y"
{ yygotominor.yy4 = 0; pd->rb_start = RB_LEN(&pd->rb); }
#line 614 "parser.c"
        break;
      case 11:
        YYTRACE("sdecl ::= STRING STRINGVAL action")
#line 66 "./parser.y"
{ 
      struct map map;
      memset(&map, 0, sizeof(map));
      map.adata = yymsp[0].minor.yy20.adata;
      map.atype = yymsp[0].minor.yy20.atype;
      map.string = stringize_token(yymsp[-1].minor.yy0);
      
      rb_append(&pd->rb, &map, sizeof(map));
      if(verbose_mode) {
            fprintf(stderr, "Appending map: ");
            dump_maps(stderr, &map, 1);
        }
}
#line 632 "parser.c"
        /* No destructor defined for STRING */
        break;
  };
  yygoto = yyRuleInfo[yyruleno].lhs;
  yysize = yyRuleInfo[yyruleno].nrhs;
  yypParser->idx -= yysize;
  yypParser->top -= yysize;
  yyact = yy_find_parser_action(yypParser,yygoto);
  if( yyact < YYNSTATE ){
    yy_shift(yypParser,yyact,yygoto,&yygotominor);
  }else if( yyact == YYNSTATE + YYNRULE + 1 ){
    yy_accept(yypParser ParseARGDECL);
  }
}

/*
** The following code executes when the parse fails
*/
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
  ParseANSIARGDECL              /* Extra arguments (if any) */
){
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->idx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
#line 86 "./parser.y"

   ParseFree(yypParser, free);
   longjmp(pd->error_jmp, 1);

#line 668 "parser.c"
}

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  YYMINORTYPE yyminor            /* The minor type of the error token */
  ParseANSIARGDECL               /* Extra arguments (if any) */
){
#define TOKEN (yyminor.yy0)
#line 81 "./parser.y"

   fprintf(stderr, "%s:%i:syntax error\n", pd->filename, pd->line);
   pd->errorcount++;

#line 686 "parser.c"
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
  ParseANSIARGDECL              /* Extra arguments (if any) */
){
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
  while( yypParser->idx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "ParseAlloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void Parse(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  ParseTOKENTYPE yyminor       /* The value for the token */
  ParseANSIARGDECL
){
  YYMINORTYPE yyminorunion;
  int yyact;            /* The parser action. */
  int yyendofinput;     /* True if we are at the end of input */
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
  yyParser *yypParser;  /* The parser */

  /* (re)initialize the parser, if necessary */
  yypParser = (yyParser*)yyp;
  if( yypParser->idx<0 ){
    if( yymajor==0 ) return;
    yypParser->idx = 0;
    yypParser->errcnt = -1;
    yypParser->top = &yypParser->stack[0];
    yypParser->top->stateno = 0;
    yypParser->top->major = 0;
  }
  yyminorunion.yy0 = yyminor;
  yyendofinput = (yymajor==0);

#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sInput %s\n",yyTracePrompt,yyTokenName[yymajor]);
  }
#endif

  do{
    yyact = yy_find_parser_action(yypParser,yymajor);
    if( yyact<YYNSTATE ){
      yy_shift(yypParser,yyact,yymajor,&yyminorunion);
      yypParser->errcnt--;
      if( yyendofinput && yypParser->idx>=0 ){
        yymajor = 0;
      }else{
        yymajor = YYNOCODE;
      }
    }else if( yyact < YYNSTATE + YYNRULE ){
      yy_reduce(yypParser,yyact-YYNSTATE ParseARGDECL);
    }else if( yyact == YY_ERROR_ACTION ){
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->errcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion ParseARGDECL);
      }
      if( yypParser->top->major==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yymajor,&yyminorunion);
        yymajor = YYNOCODE;
      }else{
         while(
          yypParser->idx >= 0 &&
          yypParser->top->major != YYERRORSYMBOL &&
          (yyact = yy_find_parser_action(yypParser,YYERRORSYMBOL)) >= YYNSTATE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->idx < 0 || yymajor==0 ){
          yy_destructor(yymajor,&yyminorunion);
          yy_parse_failed(yypParser ParseARGDECL);
          yymajor = YYNOCODE;
        }else if( yypParser->top->major!=YYERRORSYMBOL ){
          YYMINORTYPE u2;
          u2.YYERRSYMDT = 0;
          yy_shift(yypParser,yyact,YYERRORSYMBOL,&u2);
        }
      }
      yypParser->errcnt = 3;
      yyerrorhit = 1;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->errcnt<=0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion ParseARGDECL);
      }
      yypParser->errcnt = 3;
      yy_destructor(yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser ParseARGDECL);
      }
      yymajor = YYNOCODE;
#endif
    }else{
      yy_accept(yypParser ParseARGDECL);
      yymajor = YYNOCODE;
    }
  }while( yymajor!=YYNOCODE && yypParser->idx>=0 );
  return;
}
