#ifndef RESIZEABLE_BUF_H
#define RESIZEABLE_BUF_H

#include <stdlib.h>

typedef struct rb rb_t;

struct rb {
	void *buf;
	unsigned len;
	unsigned size;
}; 


#define RB_BLANK	{NULL, 0, 0}
#define RB_PTR(b)	((b)->buf)
#define RB_LEN(b)	((b)->len)
#define RB_CLEAR(b)	((b)->len = 0)
#define RB_FREE(b)	do {(b)->len = (b)->size = 0; free((b)->buf); (b)->buf = NULL;} while(0)
#define RB_INIT(b)	do {(b)->len = (b)->size = 0; (b)->buf = NULL;} while(0)

void rb_append(rb_t *rb, void *data, size_t len);
void rb_set(rb_t *rb, void *data, size_t len);
void rbs_set(rb_t *rb, char *str);
void rbs_append(rb_t *rb, char *str);
void rb_extract(rb_t *rb, rb_t *rb2, unsigned loc, size_t len);
void rb_insert(rb_t *rb, unsigned loc, char *data, size_t len);
void rb_delete(rb_t *rb, unsigned loc, size_t len);
void rb_stringize(rb_t *rb);

#endif
